#include "formats.h"

enum {
	IRCTXT_MODULE_NAME,

	IRCTXT_FILL_1,

	IRCTXT_LINE_START,
	IRCTXT_LINE_START_IRSSI,
	IRCTXT_TIMESTAMP,
	IRCTXT_SERVERTAG,
	IRCTXT_DAYCHANGE,
	IRCTXT_TALKING_WITH,
	IRCTXT_REFNUM_TOO_LOW,
	IRCTXT_WINDOWLIST_HEADER,
	IRCTXT_WINDOWLIST_LINE,
	IRCTXT_WINDOWLIST_FOOTER,

	IRCTXT_FILL_2,

	IRCTXT_LOOKING_UP,
	IRCTXT_CONNECTING,
	IRCTXT_CONNECTION_ESTABLISHED,
	IRCTXT_CANT_CONNECT,
	IRCTXT_CONNECTION_LOST,
	IRCTXT_LAG_DISCONNECTED,
	IRCTXT_DISCONNECTED,
	IRCTXT_SERVER_QUIT,
	IRCTXT_SERVER_CHANGED,
	IRCTXT_UNKNOWN_SERVER_TAG,
	IRCTXT_SERVER_LIST,
	IRCTXT_SERVER_LOOKUP_LIST,
	IRCTXT_SERVER_RECONNECT_LIST,
	IRCTXT_RECONNECT_REMOVED,
	IRCTXT_RECONNECT_NOT_FOUND,
	IRCTXT_SETUPSERVER_ADDED,
	IRCTXT_SETUPSERVER_REMOVED,
	IRCTXT_SETUPSERVER_NOT_FOUND,

	IRCTXT_FILL_3,

	IRCTXT_JOIN,
	IRCTXT_PART,
	IRCTXT_KICK,
	IRCTXT_QUIT,
	IRCTXT_QUIT_ONCE,
	IRCTXT_INVITE,
	IRCTXT_NEW_TOPIC,
	IRCTXT_TOPIC_UNSET,
	IRCTXT_YOUR_NICK_CHANGED,
	IRCTXT_NICK_CHANGED,
	IRCTXT_TALKING_IN,
	IRCTXT_NOT_IN_CHANNELS,
	IRCTXT_CURRENT_CHANNEL,
	IRCTXT_CHANLIST_HEADER,
	IRCTXT_CHANLIST_LINE,
	IRCTXT_CHANSETUP_NOT_FOUND,
	IRCTXT_CHANSETUP_ADDED,
	IRCTXT_CHANSETUP_REMOVED,
	IRCTXT_CHANSETUP_HEADER,
	IRCTXT_CHANSETUP_LINE,
	IRCTXT_CHANSETUP_FOOTER,

        IRCTXT_FILL_4,

	IRCTXT_OWN_MSG,
	IRCTXT_OWN_MSG_CHANNEL,
	IRCTXT_OWN_MSG_PRIVATE,
	IRCTXT_OWN_MSG_PRIVATE_QUERY,
	IRCTXT_PUBMSG_ME,
	IRCTXT_PUBMSG_ME_CHANNEL,
	IRCTXT_PUBMSG_HILIGHT,
	IRCTXT_PUBMSG_HILIGHT_CHANNEL,
	IRCTXT_PUBMSG,
	IRCTXT_PUBMSG_CHANNEL,
	IRCTXT_MSG_PRIVATE,
	IRCTXT_MSG_PRIVATE_QUERY,
	IRCTXT_NO_MSGS_GOT,
	IRCTXT_NO_MSGS_SENT,

	IRCTXT_FILL_5,

	IRCTXT_QUERY_STARTED,
	IRCTXT_NO_QUERY,
	IRCTXT_QUERY_SERVER_CHANGED,

	IRCTXT_FILL_6,

	IRCTXT_HILIGHT_HEADER,
	IRCTXT_HILIGHT_LINE,
	IRCTXT_HILIGHT_FOOTER,
	IRCTXT_HILIGHT_NOT_FOUND,
	IRCTXT_HILIGHT_REMOVED,

	IRCTXT_FILL_7,

	IRCTXT_ALIAS_ADDED,
	IRCTXT_ALIAS_REMOVED,
	IRCTXT_ALIAS_NOT_FOUND,
	IRCTXT_ALIASLIST_HEADER,
	IRCTXT_ALIASLIST_LINE,
	IRCTXT_ALIASLIST_FOOTER,

	IRCTXT_FILL_8,

	IRCTXT_LOG_OPENED,
	IRCTXT_LOG_CLOSED,
	IRCTXT_LOG_CREATE_FAILED,
	IRCTXT_LOG_LOCKED,
	IRCTXT_LOG_NOT_OPEN,
	IRCTXT_LOG_STARTED,
	IRCTXT_LOG_STOPPED,
	IRCTXT_LOG_LIST_HEADER,
	IRCTXT_LOG_LIST,
	IRCTXT_LOG_LIST_FOOTER,
	IRCTXT_WINDOWLOG_FILE,
	IRCTXT_WINDOWLOG_FILE_LOGGING,
	IRCTXT_LOG_NO_AWAY_MSGS,
	IRCTXT_LOG_AWAY_MSGS,

	IRCTXT_FILL_9,

	IRCTXT_MODULE_ALREADY_LOADED,
	IRCTXT_MODULE_LOAD_ERROR,
	IRCTXT_MODULE_INVALID,
	IRCTXT_MODULE_LOADED,
	IRCTXT_MODULE_UNLOADED,

	IRCTXT_FILL_10,

	IRCTXT_COMMAND_UNKNOWN,
	IRCTXT_COMMAND_AMBIGUOUS,
	IRCTXT_OPTION_UNKNOWN,
	IRCTXT_OPTION_AMBIGUOUS,
	IRCTXT_OPTION_MISSING_ARG,
	IRCTXT_NOT_ENOUGH_PARAMS,
	IRCTXT_NOT_CONNECTED,
	IRCTXT_NOT_JOINED,
	IRCTXT_CHAN_NOT_FOUND,
	IRCTXT_CHAN_NOT_SYNCED,
	IRCTXT_NOT_GOOD_IDEA,

	IRCTXT_FILL_11,

	IRCTXT_THEME_SAVED,
	IRCTXT_THEME_SAVE_FAILED,
	IRCTXT_THEME_NOT_FOUND,
	IRCTXT_WINDOW_THEME_CHANGED,
	IRCTXT_FORMAT_TITLE,
	IRCTXT_FORMAT_SUBTITLE,
	IRCTXT_FORMAT_ITEM,

	IRCTXT_FILL_12,

	IRCTXT_IGNORED,
	IRCTXT_UNIGNORED,
	IRCTXT_IGNORE_NOT_FOUND,
	IRCTXT_IGNORE_NO_IGNORES,
	IRCTXT_IGNORE_HEADER,
	IRCTXT_IGNORE_LINE,
	IRCTXT_IGNORE_FOOTER,

	IRCTXT_FILL_13,

	IRCTXT_NOT_TOGGLE,
	IRCTXT_PERL_ERROR,
	IRCTXT_BIND_KEY,
	IRCTXT_BIND_UNKNOWN_ID,
	IRCTXT_CONFIG_SAVED,
	IRCTXT_CONFIG_RELOADED,
	IRCTXT_CONFIG_MODIFIED
};

extern FORMAT_REC fecommon_core_formats[];
